//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "SimpleLongInt0.h"
#include <math.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

#define min(a,b)  ((a)>(b))?(b):(a)
#define max(a,b)  ((a)<(b))?(b):(a)
char numbers[] = "0123456789";
class LongInt
{ protected:
    AnsiString result;
  public:
    LongInt()
    { result = "0";
    }
    LongInt(int n)
    { if ( n==0 )
        { result = "0";
          return;
        }
      while(n>0)
        { result = result + numbers[n%10];
          n /= 10;
        }
    }
    LongInt(AnsiString value)
    {
      reverse(value);
      result = value;
    }
    void removeZero()
    { int len=0;
      for (int k=result.Length(); k>1; --k)
         { if ( result[k]=='0' )
             { ++len;
             }
           else break;
         }
      if ( len!=0 )
        result.SetLength(result.Length()-len);
    }
    void reverse(AnsiString &value)
    { char ch;
      for (int k=1; k<=value.Length()/2; ++k)
         { ch = value[k];
           value[k] = value[value.Length()-k+1];
           value[value.Length()-k+1] = ch;
         }
    }
    void setValue(int value)
    { LongInt temp(value);
      result = temp.result;
    }
    void setValue(LongInt value)
    {
      result = value.result;
    }
    void add(LongInt value)
    { int digits, n, c;
      AnsiString temp;

      if ( result.Length() < value.length() )  //
        { temp   = result;
          result = value.result;
        }
      else
        temp = value.result;
      digits = temp.Length();
      c = 0;
      for (int k=1; k<=digits; ++k)
         { n = (temp[k]-'0') + (result[k]-'0') + c; //StrToInt(temp[k]) + StrToInt(result[k]) + c;
           result[k] = numbers[n%10];
           c = n/10;
         }
      while( c>0 )
        { ++digits;
          if ( digits<=result.Length() )
            { n = (result[digits]-'0') + c;
              result[digits] = numbers[n % 10];
              c = n/10;
            }
          else
            { result = result + (AnsiString)numbers[c];
              break;
            }
        }
    }
    void add(AnsiString value)
    { LongInt temp(value);
      add(temp);
    }
    void add(int value)
    { LongInt temp(value);
      add(temp);
    }
    static int compare(LongInt a, LongInt b) // (-1, 0, 1) => (a>b, a=b, a<b)
    { int sign;
      if ( a.length()>b.length() )
        sign = 1;
      else if ( a.length()<b.length() )
        sign = -1;
      else
        { int k;
          for (k=a.length(); k>0; --k)
             { if ( a.result[k]!=b.result[k] )
                 break;
             }
          if ( k==0 ) sign = 0;
          else if ( a.result[k]>b.result[k] )
            sign = 1;
          else sign = -1;
        }
      return (sign);
    }
    void sub(LongInt value)    // kHɼƤ覡B
    { int sign = compare(*this, value);
      if ( sign<0 )
        { ShowMessage("Negative Error!");
          return;
        }
      else if ( sign==0 )
        { result = "0";
          return;
        }
      int digits, n, c;
      AnsiString temp = AnsiString::StringOfChar('9', result.Length());

      digits = value.length();
      for (int k=1; k<=digits; ++k)
         { temp[k] = numbers['9' - value.result[k]];  // 9 ɼ
         }
      digits = result.Length();
      reverse(temp);
      add(temp);
      //if ( result.Length()>digits ) // carry
        { result.SetLength(digits);
          add(1);
        }
      removeZero();
    }
    void sub(int value)
    { LongInt temp(value);
      sub(temp);
    }
    void mul(int value)
    { int digits, n, c=0;
      digits = result.Length();
      for (int k=1; k<=digits; ++k)
         { n = c + (result[k]-'0')*value; //StrToInt(result[k]) * value;
           result[k] = numbers[n%10];
           c = n/10;
         }
      while ( c>0 )
        { result += numbers[c%10];
          c /= 10;
        }
    }
    void mul(LongInt value)
    { int digits, n, c=0;
      LongInt temp;
      AnsiString factor;
      digits = value.length();
      factor = result;
      result = "0";
      for (int k=1; k<=digits; ++k)
         { n = value.result[k]-'0'; //StrToInt(value.result[k]);

           temp.result = factor;
        //Form1->Memo1->Lines->Add(temp.result);  // for testing
           temp.mul(n);
           add(temp);
        //Form1->Memo1->Lines->Add(result);
           factor = "0" + factor;
         }
    }
    void mul(AnsiString value)
    { LongInt temp(value);
   //Form1->Memo1->Lines->Add(temp.result);
      mul(temp);
    }
    //AnsiString show() { return result; }
    AnsiString show()
    { AnsiString temp = result;
      reverse(temp);
      return temp;
    }
    int length() { return result.Length(); }

};

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  int Times = Edit1->Text.ToIntDef(0);  //D
  Memo1->Clear();
  int Input = Edit2->Text.ToIntDef(0);  //}誺
  LongInt Num((int)sqrt(Input));        //}誺Ƴ
  int v = Input - pow((int)sqrt(Input),2);
  LongInt work(v);
  LongInt temp(0);
  AnsiString Output;  //̲׿XG
  Output = Num.show();

  Screen->Cursor = crHourGlass;

  if (LongInt::compare(work,0)!=0)
  {
    Output = Output + ".";
    Num.add(Num);

    for (int i=0 ; i<Times ; i++)
       { if (LongInt::compare(work, 0)==0)
           break;
         work.mul(100);
         Num.mul(10);

         if ( LongInt::compare(work, Num)==-1 )
           {
             Output = Output + "0";
           }
         else
           { for (int j=2 ; j<=10 ; j++)
               { temp.setValue(Num);
                 temp.add(j);
                 temp.mul(j);
                 if ( LongInt::compare(work, temp)==-1 )
                   {
                     temp.setValue(Num);
                     temp.add(j-1);
                     temp.mul(j-1);
                     //temp = (Num+(j-1))*(j-1);
                     Num.add((j-1)*2);
                     work.sub(temp);
                     Output = Output + IntToStr(j-1);
                     break;
                   }
                }
           }

       }
  }
  Memo1->Lines->Add(Output);
  Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormResize(TObject *Sender)
{
  Memo1->Width = Form1->ClientWidth;        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  Memo1->Lines->Clear();        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{ int n;
  LongInt fac(1);
  n = StrToInt(Edit1->Text);

  Screen->Cursor = crHourGlass;

  for (int k=1; k<=n; ++k)
     fac.mul(k);
  Memo1->Lines->Add(fac.show());

  Screen->Cursor = crDefault;

}
//---------------------------------------------------------------------------

